------------------------------------------------------------------------------
--
--  Xilinx, Inc. 2005                 www.xilinx.com
--
------------------------------------------------------------------------------
--
--  File name :       top_async3.vhd
--
--  Description :     Generic top level file to show LVDS pin inversion for asynchronous inputs
--
--  Date - revision : April 4th 2006 - v 1.0
--
--  Author :          NJS
--
--  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are
--              provided to you "as is". Xilinx and its licensors make and you
--              receive no warranties or conditions, express, implied,
--              statutory or otherwise, and Xilinx specifically disclaims any
--              implied warranties of merchantability, non-infringement,or
--              fitness for a particular purpose. Xilinx does not warrant that
--              the functions contained in these designs will meet your
--              requirements, or that the operation of these designs will be
--              uninterrupted or error free, or that defects in the Designs
--              will be corrected. Furthermore, Xilinx does not warrantor
--              make any representations regarding use or the results of the
--              use of the designs in terms of correctness, accuracy,
--              reliability, or otherwise.
--
--              LIMITATION OF LIABILITY. In no event will Xilinx or its
--              licensors be liable for any loss of data, lost profits,cost
--              or procurement of substitute goods or services, or for any
--              special, incidental, consequential, or indirect damages
--              arising from the use or operation of the designs or
--              accompanying documentation, however caused and on any theory
--              of liability. This limitation will apply even if Xilinx
--              has been advised of the possibility of such damage. This
--              limitation shall apply not-withstanding the failure of the
--              essential purpose of any limited remedies herein.
--
--  Copyright  2005 Xilinx, Inc.
--  All rights reserved
--
------------------------------------------------------------------------------
--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all ;

library unisim ;
use unisim.vcomponents.all ;

entity top_async3 is port (
	datain_p, datain_n 		: in std_logic_vector(2 downto 0);	-- data inputs
	tp				: out std_logic); 			-- dummy output
end top_async3;

architecture arch_top_async3 of top_async3 is

signal rx_input	 	: std_logic_vector(2 downto 0) ;
signal rx_input_fix  	: std_logic_vector(2 downto 0) ;
	
constant SWAP_MASK  	: std_logic_vector(2 downto 0) := "101" ;

begin
	
loop0 : for i in 0 to 2 generate 
ibuf_d : ibufds generic map (IOSTANDARD => "LVDS_25", IBUF_DELAY_VALUE => "0", DIFF_TERM => FALSE) 
	        port map    (i => datain_p(i), iB => datain_n(i), o => rx_input(i));
rx_input_fix(i) <= rx_input(i) xor SWAP_MASK(i) ;
end generate ;

tp <= rx_input_fix(2) and rx_input_fix(1) and rx_input_fix(0) ;

end arch_top_async3 ;


